package ims;

import java.awt.*;
import java.awt.event.*; 
import java.util.*;

//IMS General Class

public class imsGeneral extends Any{

  public String identifier;
  
  public imsLangString title;   
  public imsCatalogEntry[] catalogentry;
  public String[] language;
  public imsLangString[] description;
  public imsLangString[] keywords;
  public imsLangString[] coverage;
  public imsLangString structure;
  public String aggregationlevel;
  
  public imsGeneral(imsLangString aTitle, imsCatalogEntry[] aCatalogEntry, String[] aLanguage, imsLangString[] aDescription) {
    title = aTitle;         
    catalogentry = aCatalogEntry; 
    language = aLanguage;
    description = aDescription;
    
    keywords = null;
    coverage = null;
    structure = null;
    aggregationlevel = null;
  }
  
  public imsGeneral(imsLangString aTitle, imsCatalogEntry[] aCatalogEntry, 
                    String[] aLanguage, imsLangString[] aDescription,
                    imsLangString[] aKeywords, imsLangString[] aCoverage,
                    imsLangString aStructure, String aAggregationLevel) {
    title = aTitle;         
    catalogentry = aCatalogEntry; 
    language = aLanguage;
    description = aDescription;
    
    keywords = aKeywords;
    coverage = aCoverage;
    structure = aStructure;
    aggregationlevel = aAggregationLevel;
  }

  public String imsWrite2XMLString() {
    StringBuffer sb = new StringBuffer("<GENERAL>\n");

    sb.append("<TITLE>"+title.imsWrite2XMLString()+"</TITLE>\n");
      
    sb.append("<CATALOGENTRY>\n");
    for(int i=0; i < catalogentry.length; i++)
      sb.append(catalogentry[i].imsWrite2XMLString());
    sb.append("</CATALOGENTRY>\n");

    for(int i=0; i < language.length; i++)
      sb.append("<LANGUAGE>"+language[i]+"</LANGUAGE>\n");
    
    sb.append("<DESCRIPTION>\n");
    for(int i=0; i < description.length; i++)
      sb.append(description[i].imsWrite2XMLString());
    sb.append("</DESCRIPTION>\n");

    if(keywords != null) {
      for(int i=0; i < keywords.length; i++)
        sb.append("<KEYWORDS>\n"+keywords[i].imsWrite2XMLString()+"</KEYWORDS>\n");
    }

    if(coverage != null) {
      for(int i=0; i < coverage.length; i++)
        sb.append("<COVERAGE>\n"+coverage[i].imsWrite2XMLString()+"</COVERAGE>\n");
    }

    if(structure != null)
      sb.append("<STRUCTURE>\n"+structure.imsWrite2XMLString()+"</STRUCTURE>\n");
      
    if(aggregationlevel != null)
      sb.append("<AGGREGATIONLEVEL>"+aggregationlevel+"</AGGREGATIONLEVEL>\n");

    sb.append("</GENERAL>");
    return sb.toString();
  }

}
