package sri;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import ims.*;

public class IMSCoreServlet extends HttpServlet {
  public String getServletInfo() {
    return "A servlet for generating IMS metadata descriptions";
  }

  public void doPost(HttpServletRequest req, HttpServletResponse resp)
    throws ServletException, IOException {
		
	resp.setContentType("text/plain");
	PrintWriter out = resp.getWriter();

  // Stuff for General
  	imsCatalogEntry[] catalogentry = new imsCatalogEntry[1];
  	  catalogentry[0] = new imsCatalogEntry(req.getParameter("Gcatalogue"), new imsLangString(req.getParameter("Gentry")));

	String[] language = new String[1];
	  language[0] = req.getParameter("Glanguage");

	imsLangString[] descriptions = new imsLangString[1];
	  descriptions[0] = new imsLangString(req.getParameter("Gdescription"));
	
  // Stuff for LifeCycle
	imsVCard[] authors = new imsVCard[2];
	  authors[0] = new imsVCard(req.getParameter("Lname1"), req.getParameter("Lorg1"), req.getParameter("Lemail1"), req.getParameter("Laddress1"), req.getParameter("Lphone1"));
	  authors[1] = new imsVCard(req.getParameter("Lname2"), req.getParameter("Lorg2"), req.getParameter("Lemail2"), req.getParameter("Laddress2"), req.getParameter("Lphone2"));
	
	imsVCard[] publishers = new imsVCard[1];
	  publishers[0] = new imsVCard(req.getParameter("Lname3"), req.getParameter("Lorg3"), req.getParameter("Lemail3"), req.getParameter("Laddress3"), req.getParameter("Lphone3"));
	
	imsContribute contribute[] = new imsContribute[2];
	  contribute[0] = new imsContribute(new imsLangString(req.getParameter("Lrole1")), authors, new imsDateTime(req.getParameter("Ldate1")));
	  contribute[1] = new imsContribute(new imsLangString(req.getParameter("Lrole2")), publishers, new imsDateTime(req.getParameter("Ldate2")));

	
  // Stuff for Technical
	imsLangString[] format = new imsLangString[1];
	  format[0] = new imsLangString(req.getParameter("Tformat"));
	
	imsLocation[] location = new imsLocation[1];
	  location[0] = new imsLocation(req.getParameter("Tlocation"),  req.getParameter("Tlocationtype"));
	
	imsLangString[] versions = new imsLangString[1];
      versions[0] = new imsLangString(req.getParameter("Lversion"));

  // Stuff for Rights
	imsLangString[] description = new imsLangString[1];
	  description[0] = new imsLangString(req.getParameter("Rdescription"));
	
  // Stuff for Classification
	imsLangString[] keywords = new imsLangString[4];
	  keywords[0] = new imsLangString(req.getParameter("Ckeyword1"));
	  keywords[1] = new imsLangString(req.getParameter("Ckeyword2"));
	  keywords[2] = new imsLangString(req.getParameter("Ckeyword3"));
	  keywords[3] = new imsLangString(req.getParameter("Ckeyword4"));
		
	imsClassification[] classification = new imsClassification[1];
	  classification[0] = new imsClassification(new imsLangString(req.getParameter("Cpurpose")), 
															 new imsLangString(req.getParameter("Cdescription")), 
															 keywords);
	
  // Create a Core object
	imsCore core = new imsCore(new imsMetaMetaData(req.getParameter("Mmetadatascheme"), req.getParameter("Mlanguage")),
							   new imsGeneral(new imsLangString(req.getParameter("Gtitle")), catalogentry, language, descriptions),
							   new imsLifeCycle(new imsLangString(versions), contribute),
							   new imsTechnical(format, location),
							   new imsRights(new imsLangString(req.getParameter("Rcost")), new imsLangString(req.getParameter("Rcopyrightorotherrestrictions")), description),
							   classification);
							
  // Print it to browser	   
	out.print(core.imsWrite2XMLString());
	out.close();

  }
}